using System;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;

public partial class controls_socialbookmarks : System.Web.UI.UserControl
{
  protected void Page_Load(object sender, EventArgs e)
  {
    if (!Page.IsPostBack)
    {
      AddBookmarks();
    }
  }

  private void AddBookmarks()
  {
    AddBookmark("http://digg.com/submit?phase=2&url={0}&title={1}", "Digg");
    AddBookmark("http://del.icio.us/post?url={0}&title={1}", "del.icio.us");
    AddBookmark("http://www.furl.net/storeIt.jsp?u={0}&t={1}", "FURL");
    AddBookmark("http://reddit.com/submit?url={0}&title={1}", "Reddit");
    AddBookmark("http://myweb2.search.yahoo.com/myresults/bookmarklet?u={0}&t={1}", "Yahoo");
    AddBookmark("http://www.blinklist.com/index.php?Action=Blink/addblink.php &Quick=true&Url={0}&Title={1}&Pop=yes", "Blinklist");
    AddBookmark("http://www.google.com/bookmarks/mark?op=edit&output=popup&bkmk={0}&title={1}", "Google");
    AddBookmark("http://ma.gnolia.com/bookmarklet/add? url={0}&title={1}", "ma.gnolia");
    AddBookmark("http://www.shadows.com/features/tcr.htm?url={0}&title={1}", "Shadows");
    AddBookmark("http://technorati.com/faves?add={0}", "Technorati");
  }

  public void AddBookmark(string urlProviderFormat, string providerName)
  {
    HtmlAnchor anchor = new HtmlAnchor();
    anchor.HRef = Server.HtmlEncode(string.Format(urlProviderFormat, PageUrl, PageTitle));
    anchor.Title = LinkTitlePrefix + " " + providerName;

    if (OpenNewWindow)
      anchor.Target = "_Blank";

    Image img = new Image();
    img.ImageUrl = "~/pics/bookmarks/" + providerName + ".png";
    img.AlternateText = LinkTitlePrefix + " " + providerName;
    img.Style.Add(HtmlTextWriterStyle.MarginRight, "5px");

    anchor.Controls.Add(img);
    phBookmarks.Controls.Add(anchor);
  }

  #region Properties

  public string PageUrl
  {
    get { return (string)(ViewState["PageUrl"] ?? Request.Url.ToString()); }
    set { ViewState["PageUrl"] = value; }
  }

  public string PageTitle
  {
    get { return (string)(ViewState["PageTitle"] ?? Page.Title); }
    set { ViewState["PageTitle"] = value; }
  }

  public bool OpenNewWindow
  {
    get { return (bool)(ViewState["OpenNewWindow"] ?? false); }
    set { ViewState["OpenNewWindow"] = value; }
  }

  public string LinkTitlePrefix
  {
    get { return (string)(ViewState["LinkTitlePrefix"] ?? "Add to"); }
    set { ViewState["LinkTitlePrefix"] = value; }
  }

  #endregion

}
